/* clipboard-item.c generated by valac 0.30.2, the Vala compiler
 * generated from clipboard-item.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>


#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};



GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
DiodonClipboardType diodon_iclipboard_item_get_clipboard_type (DiodonIClipboardItem* self);
gchar* diodon_iclipboard_item_get_label (DiodonIClipboardItem* self);
gchar* diodon_iclipboard_item_get_mime_type (DiodonIClipboardItem* self);
DiodonClipboardCategory diodon_iclipboard_item_get_category (DiodonIClipboardItem* self);
GtkImage* diodon_iclipboard_item_get_image (DiodonIClipboardItem* self);
GIcon* diodon_iclipboard_item_get_icon (DiodonIClipboardItem* self);
GByteArray* diodon_iclipboard_item_get_payload (DiodonIClipboardItem* self, GError** error);
GDateTime* diodon_iclipboard_item_get_date_copied (DiodonIClipboardItem* self);
gchar* diodon_iclipboard_item_get_text (DiodonIClipboardItem* self);
gchar* diodon_iclipboard_item_get_checksum (DiodonIClipboardItem* self);
gchar* diodon_iclipboard_item_get_origin (DiodonIClipboardItem* self);
void diodon_iclipboard_item_to_clipboard (DiodonIClipboardItem* self, GtkClipboard* clipboard);
gboolean diodon_iclipboard_item_equals (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
guint diodon_iclipboard_item_hash (DiodonIClipboardItem* self);
gboolean diodon_iclipboard_item_equal_func (DiodonIClipboardItem* item_a, DiodonIClipboardItem* item_b);
guint diodon_iclipboard_item_hash_func (DiodonIClipboardItem* item);


/**
         * get clipboard type item is coming from
         *
         * @return type of clipboard
         */
DiodonClipboardType diodon_iclipboard_item_get_clipboard_type (DiodonIClipboardItem* self) {
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), 0);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_clipboard_type (self);
#line 110 "clipboard-item.c"
}


/**
         * label of clipboard item used to show in user interface
         *
         * @return label of item
         */
gchar* diodon_iclipboard_item_get_label (DiodonIClipboardItem* self) {
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_label (self);
#line 124 "clipboard-item.c"
}


/**
         * get mime type of given clipboard item
         *
         * @return mime type of item
         */
gchar* diodon_iclipboard_item_get_mime_type (DiodonIClipboardItem* self) {
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 53 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_mime_type (self);
#line 138 "clipboard-item.c"
}


/**
         * get clipboard category item belongs to
         *
         * @return clipboard category
         */
DiodonClipboardCategory diodon_iclipboard_item_get_category (DiodonIClipboardItem* self) {
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), 0);
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_category (self);
#line 152 "clipboard-item.c"
}


/**
         * image to represent content of clipboard item
         *
         * @return image of item or null if not available
         */
GtkImage* diodon_iclipboard_item_get_image (DiodonIClipboardItem* self) {
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_image (self);
#line 166 "clipboard-item.c"
}


/**
         * icon to represent type of clipboard item
         *
         * @return icon of clipboard type
         */
GIcon* diodon_iclipboard_item_get_icon (DiodonIClipboardItem* self) {
#line 74 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 74 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_icon (self);
#line 180 "clipboard-item.c"
}


/**
         * Retrieves any additional data needed to reconstruct clipboard content
         */
GByteArray* diodon_iclipboard_item_get_payload (DiodonIClipboardItem* self, GError** error) {
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 79 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_payload (self, error);
#line 192 "clipboard-item.c"
}


/**
         * Date of when clipboard item has been copied
         *
         * @return date
         */
GDateTime* diodon_iclipboard_item_get_date_copied (DiodonIClipboardItem* self) {
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 86 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_date_copied (self);
#line 206 "clipboard-item.c"
}


/**
         * A string representing clipboard item.
         *
         * @return data
         */
gchar* diodon_iclipboard_item_get_text (DiodonIClipboardItem* self) {
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_text (self);
#line 220 "clipboard-item.c"
}


/**
         * Get unique checksum for clipboard content.
         */
gchar* diodon_iclipboard_item_get_checksum (DiodonIClipboardItem* self) {
#line 98 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 98 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_checksum (self);
#line 232 "clipboard-item.c"
}


/**
         * Get origin resp. path of application which has triggered copy event
         * creating this clipboard item.
         *
         * @return origin as application path if available; otherwise null
         */
gchar* diodon_iclipboard_item_get_origin (DiodonIClipboardItem* self) {
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), NULL);
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->get_origin (self);
#line 247 "clipboard-item.c"
}


/**
         * Select the current item in the given gtk clipboard
         *
         * @param clipboard gtk clipboard
         */
void diodon_iclipboard_item_to_clipboard (DiodonIClipboardItem* self, GtkClipboard* clipboard) {
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self));
#line 113 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->to_clipboard (self, clipboard);
#line 261 "clipboard-item.c"
}


/**
         * Check if given item is equal.
         *
         * @return true if equal; otherwise false.
         *
         */
gboolean diodon_iclipboard_item_equals (DiodonIClipboardItem* self, DiodonIClipboardItem* item) {
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), FALSE);
#line 121 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->equals (self, item);
#line 276 "clipboard-item.c"
}


/**
         * return hash code for implemented clipboard item
         *
         * @return hash code
         *
         */
guint diodon_iclipboard_item_hash (DiodonIClipboardItem* self) {
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (self), 0U);
#line 129 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return DIODON_ICLIPBOARD_ITEM_GET_INTERFACE (self)->hash (self);
#line 291 "clipboard-item.c"
}


/**
         * equal func helper comparing two clipboard items.
         *
         * @param item_a item to be compared
         * @param item_b other item to be compared
         * 
         * @return true if equal; otherwise false.
         */
gboolean diodon_iclipboard_item_equal_func (DiodonIClipboardItem* item_a, DiodonIClipboardItem* item_b) {
	gboolean result = FALSE;
	DiodonIClipboardItem* _tmp0_ = NULL;
	DiodonIClipboardItem* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	_tmp0_ = item_a;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	_tmp1_ = item_b;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	_tmp2_ = diodon_iclipboard_item_equals (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem), _tmp1_);
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	result = _tmp2_;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return result;
#line 318 "clipboard-item.c"
}


/**
         * hash func helper creating hash code for clipboard item.
         * 
         * @param item item to create hash from
         * 
         * @return generated hash code
         */
guint diodon_iclipboard_item_hash_func (DiodonIClipboardItem* item) {
	guint result = 0U;
	DiodonIClipboardItem* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	_tmp0_ = item;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	_tmp1_ = diodon_iclipboard_item_hash (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	result = _tmp1_;
#line 153 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	return result;
#line 341 "clipboard-item.c"
}


static void diodon_iclipboard_item_base_init (DiodonIClipboardItemIface * iface) {
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	static gboolean initialized = FALSE;
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
	if (!initialized) {
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-item.vala"
		initialized = TRUE;
#line 352 "clipboard-item.c"
	}
}


/**
     * Clipboard item interface to be implemented by various different
     * clipboard item types such as Text,File or Image.
     *
     * TODO
     * interface IClipboardItem should extends Gee.Hashable which currently ends
     * in a compliation error of classes implenting this interface.
     */
GType diodon_iclipboard_item_get_type (void) {
	static volatile gsize diodon_iclipboard_item_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_iclipboard_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonIClipboardItemIface), (GBaseInitFunc) diodon_iclipboard_item_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType diodon_iclipboard_item_type_id;
		diodon_iclipboard_item_type_id = g_type_register_static (G_TYPE_INTERFACE, "DiodonIClipboardItem", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (diodon_iclipboard_item_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&diodon_iclipboard_item_type_id__volatile, diodon_iclipboard_item_type_id);
	}
	return diodon_iclipboard_item_type_id__volatile;
}



