/* clipboard-menu-item.c generated by valac 0.30.2, the Vala compiler
 * generated from clipboard-menu-item.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2010-2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */
/**
         * Highlight item by changing label to bold
         * TODO: get this up and running
         */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define DIODON_TYPE_CLIPBOARD_MENU_ITEM (diodon_clipboard_menu_item_get_type ())
#define DIODON_CLIPBOARD_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItem))
#define DIODON_CLIPBOARD_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItemClass))
#define DIODON_IS_CLIPBOARD_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_CLIPBOARD_MENU_ITEM))
#define DIODON_IS_CLIPBOARD_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_CLIPBOARD_MENU_ITEM))
#define DIODON_CLIPBOARD_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItemClass))

typedef struct _DiodonClipboardMenuItem DiodonClipboardMenuItem;
typedef struct _DiodonClipboardMenuItemClass DiodonClipboardMenuItemClass;
typedef struct _DiodonClipboardMenuItemPrivate DiodonClipboardMenuItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DiodonClipboardMenuItem {
	GtkImageMenuItem parent_instance;
	DiodonClipboardMenuItemPrivate * priv;
};

struct _DiodonClipboardMenuItemClass {
	GtkImageMenuItemClass parent_class;
};

struct _DiodonClipboardMenuItemPrivate {
	gchar* _checksum;
};

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};


static gpointer diodon_clipboard_menu_item_parent_class = NULL;

GType diodon_clipboard_menu_item_get_type (void) G_GNUC_CONST;
#define DIODON_CLIPBOARD_MENU_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItemPrivate))
enum  {
	DIODON_CLIPBOARD_MENU_ITEM_DUMMY_PROPERTY
};
GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
DiodonClipboardMenuItem* diodon_clipboard_menu_item_new (DiodonIClipboardItem* item);
DiodonClipboardMenuItem* diodon_clipboard_menu_item_construct (GType object_type, DiodonIClipboardItem* item);
gchar* diodon_iclipboard_item_get_checksum (DiodonIClipboardItem* self);
gchar* diodon_iclipboard_item_get_label (DiodonIClipboardItem* self);
GtkImage* diodon_iclipboard_item_get_image (DiodonIClipboardItem* self);
gchar* diodon_clipboard_menu_item_get_item_checksum (DiodonClipboardMenuItem* self);
static void diodon_clipboard_menu_item_finalize (GObject* obj);


/**
         * Clipboard item constructor
         * 
         * @param item clipboard item 
         */
DiodonClipboardMenuItem* diodon_clipboard_menu_item_construct (GType object_type, DiodonIClipboardItem* item) {
	DiodonClipboardMenuItem * self = NULL;
	DiodonIClipboardItem* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	DiodonIClipboardItem* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GtkImage* image = NULL;
	DiodonIClipboardItem* _tmp5_ = NULL;
	GtkImage* _tmp6_ = NULL;
	GtkImage* _tmp7_ = NULL;
#line 37 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	g_return_val_if_fail (DIODON_IS_ICLIPBOARD_ITEM (item), NULL);
#line 37 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	self = (DiodonClipboardMenuItem*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp0_ = item;
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp1_ = diodon_iclipboard_item_get_checksum (_tmp0_);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_g_free0 (self->priv->_checksum);
#line 39 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	self->priv->_checksum = _tmp1_;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp2_ = item;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp3_ = diodon_iclipboard_item_get_label (_tmp2_);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp4_ = _tmp3_;
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	gtk_menu_item_set_label (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_menu_item_get_type (), GtkMenuItem), _tmp4_);
#line 40 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_g_free0 (_tmp4_);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp5_ = item;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp6_ = diodon_iclipboard_item_get_image (_tmp5_);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	image = _tmp6_;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp7_ = image;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	if (_tmp7_ != NULL) {
#line 175 "clipboard-menu-item.c"
		GtkImage* _tmp8_ = NULL;
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
		_tmp8_ = image;
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
		gtk_image_menu_item_set_image (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_menu_item_get_type (), GtkImageMenuItem), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
		gtk_image_menu_item_set_always_show_image (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_menu_item_get_type (), GtkImageMenuItem), TRUE);
#line 183 "clipboard-menu-item.c"
	}
#line 37 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_g_object_unref0 (image);
#line 37 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	return self;
#line 189 "clipboard-menu-item.c"
}


DiodonClipboardMenuItem* diodon_clipboard_menu_item_new (DiodonIClipboardItem* item) {
#line 37 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	return diodon_clipboard_menu_item_construct (DIODON_TYPE_CLIPBOARD_MENU_ITEM, item);
#line 196 "clipboard-menu-item.c"
}


/**
         * Get encapsulated clipboard item checksum
         *
         * @return clipboard item checksum
         */
gchar* diodon_clipboard_menu_item_get_item_checksum (DiodonClipboardMenuItem* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 55 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	g_return_val_if_fail (DIODON_IS_CLIPBOARD_MENU_ITEM (self), NULL);
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp0_ = self->priv->_checksum;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	result = _tmp1_;
#line 57 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	return result;
#line 219 "clipboard-menu-item.c"
}


static void diodon_clipboard_menu_item_class_init (DiodonClipboardMenuItemClass * klass) {
#line 28 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	diodon_clipboard_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	g_type_class_add_private (klass, sizeof (DiodonClipboardMenuItemPrivate));
#line 28 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_clipboard_menu_item_finalize;
#line 230 "clipboard-menu-item.c"
}


static void diodon_clipboard_menu_item_instance_init (DiodonClipboardMenuItem * self) {
#line 28 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	self->priv = DIODON_CLIPBOARD_MENU_ITEM_GET_PRIVATE (self);
#line 237 "clipboard-menu-item.c"
}


static void diodon_clipboard_menu_item_finalize (GObject* obj) {
	DiodonClipboardMenuItem * self;
#line 28 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_CLIPBOARD_MENU_ITEM, DiodonClipboardMenuItem);
#line 30 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	_g_free0 (self->priv->_checksum);
#line 28 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/clipboard-menu-item.vala"
	G_OBJECT_CLASS (diodon_clipboard_menu_item_parent_class)->finalize (obj);
#line 249 "clipboard-menu-item.c"
}


/**
     * A gtk menu item holding a checksum of a clipboard item. It only keeps
     * the checksum as it would waste memory to keep the hole item available.
     */
GType diodon_clipboard_menu_item_get_type (void) {
	static volatile gsize diodon_clipboard_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_clipboard_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonClipboardMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_clipboard_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonClipboardMenuItem), 0, (GInstanceInitFunc) diodon_clipboard_menu_item_instance_init, NULL };
		GType diodon_clipboard_menu_item_type_id;
		diodon_clipboard_menu_item_type_id = g_type_register_static (gtk_image_menu_item_get_type (), "DiodonClipboardMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&diodon_clipboard_menu_item_type_id__volatile, diodon_clipboard_menu_item_type_id);
	}
	return diodon_clipboard_menu_item_type_id__volatile;
}



