/* image-clipboard-item.c generated by valac 0.30.2, the Vala compiler
 * generated from image-clipboard-item.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2011-2013 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())

#define DIODON_TYPE_IMAGE_CLIPBOARD_ITEM (diodon_image_clipboard_item_get_type ())
#define DIODON_IMAGE_CLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem))
#define DIODON_IMAGE_CLIPBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItemClass))
#define DIODON_IS_IMAGE_CLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_IMAGE_CLIPBOARD_ITEM))
#define DIODON_IS_IMAGE_CLIPBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_IMAGE_CLIPBOARD_ITEM))
#define DIODON_IMAGE_CLIPBOARD_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItemClass))

typedef struct _DiodonImageClipboardItem DiodonImageClipboardItem;
typedef struct _DiodonImageClipboardItemClass DiodonImageClipboardItemClass;
typedef struct _DiodonImageClipboardItemPrivate DiodonImageClipboardItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_checksum_free0(var) ((var == NULL) ? NULL : (var = (g_checksum_free (var), NULL)))

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};

struct _DiodonImageClipboardItem {
	GObject parent_instance;
	DiodonImageClipboardItemPrivate * priv;
};

struct _DiodonImageClipboardItemClass {
	GObjectClass parent_class;
};

struct _DiodonImageClipboardItemPrivate {
	DiodonClipboardType _clipboard_type;
	gchar* _checksum;
	GdkPixbuf* _pixbuf;
	gchar* _label;
	gchar* _origin;
	GDateTime* _date_copied;
};


static gpointer diodon_image_clipboard_item_parent_class = NULL;
static DiodonIClipboardItemIface* diodon_image_clipboard_item_diodon_iclipboard_item_parent_iface = NULL;

GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
GType diodon_image_clipboard_item_get_type (void) G_GNUC_CONST;
#define DIODON_IMAGE_CLIPBOARD_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItemPrivate))
enum  {
	DIODON_IMAGE_CLIPBOARD_ITEM_DUMMY_PROPERTY
};
DiodonImageClipboardItem* diodon_image_clipboard_item_new_with_image (DiodonClipboardType clipboard_type, GdkPixbuf* pixbuf, const gchar* origin, GDateTime* date_copied, GError** error);
DiodonImageClipboardItem* diodon_image_clipboard_item_construct_with_image (GType object_type, DiodonClipboardType clipboard_type, GdkPixbuf* pixbuf, const gchar* origin, GDateTime* date_copied, GError** error);
static void diodon_image_clipboard_item_extract_pixbuf_info (DiodonImageClipboardItem* self, GdkPixbuf* pixbuf);
DiodonImageClipboardItem* diodon_image_clipboard_item_new_with_payload (DiodonClipboardType clipboard_type, GByteArray* payload, const gchar* origin, GDateTime* date_copied, GError** error);
DiodonImageClipboardItem* diodon_image_clipboard_item_construct_with_payload (GType object_type, DiodonClipboardType clipboard_type, GByteArray* payload, const gchar* origin, GDateTime* date_copied, GError** error);
static DiodonClipboardType diodon_image_clipboard_item_real_get_clipboard_type (DiodonIClipboardItem* base);
static GDateTime* diodon_image_clipboard_item_real_get_date_copied (DiodonIClipboardItem* base);
static gchar* diodon_image_clipboard_item_real_get_text (DiodonIClipboardItem* base);
static gchar* diodon_image_clipboard_item_real_get_origin (DiodonIClipboardItem* base);
static gchar* diodon_image_clipboard_item_real_get_label (DiodonIClipboardItem* base);
static gchar* diodon_image_clipboard_item_real_get_mime_type (DiodonIClipboardItem* base);
static GIcon* diodon_image_clipboard_item_real_get_icon (DiodonIClipboardItem* base);
static GFile* diodon_image_clipboard_item_save_tmp_pixbuf (DiodonImageClipboardItem* self, GdkPixbuf* pixbuf, GError** error);
gchar* diodon_iclipboard_item_get_mime_type (DiodonIClipboardItem* self);
static DiodonClipboardCategory diodon_image_clipboard_item_real_get_category (DiodonIClipboardItem* base);
static GtkImage* diodon_image_clipboard_item_real_get_image (DiodonIClipboardItem* base);
static GdkPixbuf* diodon_image_clipboard_item_create_scaled_pixbuf (GdkPixbuf* pixbuf);
static GByteArray* diodon_image_clipboard_item_real_get_payload (DiodonIClipboardItem* base, GError** error);
static guint8* _vala_array_dup2 (guint8* self, int length);
static gchar* diodon_image_clipboard_item_real_get_checksum (DiodonIClipboardItem* base);
static void diodon_image_clipboard_item_real_to_clipboard (DiodonIClipboardItem* base, GtkClipboard* clipboard);
static gboolean diodon_image_clipboard_item_real_equals (DiodonIClipboardItem* base, DiodonIClipboardItem* item);
static guint diodon_image_clipboard_item_real_hash (DiodonIClipboardItem* base);
DiodonImageClipboardItem* diodon_image_clipboard_item_new (void);
DiodonImageClipboardItem* diodon_image_clipboard_item_construct (GType object_type);
static void diodon_image_clipboard_item_finalize (GObject* obj);


/**
         * Create image clipboard item by a pixbuf.
         * 
         * @param clipboard_type clipboard type item is coming from
         * @param pixbuf image from clipboard
         * @param origin origin of clipboard item as application path
         */
static gpointer _g_date_time_ref0 (gpointer self) {
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 162 "image-clipboard-item.c"
}


DiodonImageClipboardItem* diodon_image_clipboard_item_construct_with_image (GType object_type, DiodonClipboardType clipboard_type, GdkPixbuf* pixbuf, const gchar* origin, GDateTime* date_copied, GError** error) {
	DiodonImageClipboardItem * self = NULL;
	DiodonClipboardType _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GDateTime* _tmp3_ = NULL;
	GDateTime* _tmp4_ = NULL;
	GdkPixbuf* _tmp5_ = NULL;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (date_copied != NULL, NULL);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = (DiodonImageClipboardItem*) g_object_new (object_type, NULL);
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = clipboard_type;
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_clipboard_type = _tmp0_;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = origin;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_origin = _tmp2_;
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3_ = date_copied;
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 47 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_date_copied = _tmp4_;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp5_ = pixbuf;
#line 48 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	diodon_image_clipboard_item_extract_pixbuf_info (self, _tmp5_);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return self;
#line 206 "image-clipboard-item.c"
}


DiodonImageClipboardItem* diodon_image_clipboard_item_new_with_image (DiodonClipboardType clipboard_type, GdkPixbuf* pixbuf, const gchar* origin, GDateTime* date_copied, GError** error) {
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return diodon_image_clipboard_item_construct_with_image (DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, clipboard_type, pixbuf, origin, date_copied, error);
#line 213 "image-clipboard-item.c"
}


/**
         * Create image clipboard item by given payload.
         * 
         * @param clipboard_type clipboard type item is coming from
         * @param pixbuf image from clipboard
         * @param origin origin of clipboard item as application path
         */
static gpointer _g_object_ref0 (gpointer self) {
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return self ? g_object_ref (self) : NULL;
#line 227 "image-clipboard-item.c"
}


DiodonImageClipboardItem* diodon_image_clipboard_item_construct_with_payload (GType object_type, DiodonClipboardType clipboard_type, GByteArray* payload, const gchar* origin, GDateTime* date_copied, GError** error) {
	DiodonImageClipboardItem * self = NULL;
	DiodonClipboardType _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GDateTime* _tmp3_ = NULL;
	GDateTime* _tmp4_ = NULL;
	GdkPixbufLoader* loader = NULL;
	GdkPixbufLoader* _tmp5_ = NULL;
	GdkPixbufLoader* _tmp6_ = NULL;
	GByteArray* _tmp7_ = NULL;
	guint8* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	GdkPixbufLoader* _tmp9_ = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbufLoader* _tmp10_ = NULL;
	GdkPixbuf* _tmp11_ = NULL;
	GdkPixbuf* _tmp12_ = NULL;
	GdkPixbuf* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (payload != NULL, NULL);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (date_copied != NULL, NULL);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = (DiodonImageClipboardItem*) g_object_new (object_type, NULL);
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = clipboard_type;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_clipboard_type = _tmp0_;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = origin;
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 61 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_origin = _tmp2_;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3_ = date_copied;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp4_ = _g_date_time_ref0 (_tmp3_);
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_date_copied = _tmp4_;
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp5_ = gdk_pixbuf_loader_new ();
#line 64 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	loader = _tmp5_;
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp6_ = loader;
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp7_ = payload;
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp8_ = _tmp7_->data;
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp8__length1 = (gint) _tmp7_->len;
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	gdk_pixbuf_loader_write (_tmp6_, _tmp8_, (gsize) _tmp8__length1, &_inner_error_);
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		g_propagate_error (error, _inner_error_);
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_object_unref0 (loader);
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_object_unref0 (self);
#line 65 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		return NULL;
#line 301 "image-clipboard-item.c"
	}
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp9_ = loader;
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	gdk_pixbuf_loader_close (_tmp9_, &_inner_error_);
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		g_propagate_error (error, _inner_error_);
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_object_unref0 (loader);
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_object_unref0 (self);
#line 66 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		return NULL;
#line 317 "image-clipboard-item.c"
	}
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp10_ = loader;
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp11_ = gdk_pixbuf_loader_get_pixbuf (_tmp10_);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 67 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	pixbuf = _tmp12_;
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp13_ = pixbuf;
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	diodon_image_clipboard_item_extract_pixbuf_info (self, _tmp13_);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_object_unref0 (pixbuf);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_object_unref0 (loader);
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return self;
#line 337 "image-clipboard-item.c"
}


DiodonImageClipboardItem* diodon_image_clipboard_item_new_with_payload (DiodonClipboardType clipboard_type, GByteArray* payload, const gchar* origin, GDateTime* date_copied, GError** error) {
#line 58 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return diodon_image_clipboard_item_construct_with_payload (DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, clipboard_type, payload, origin, date_copied, error);
#line 344 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static DiodonClipboardType diodon_image_clipboard_item_real_get_clipboard_type (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	DiodonClipboardType result = 0;
	DiodonClipboardType _tmp0_ = 0;
#line 74 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_clipboard_type;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp0_;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 363 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GDateTime* diodon_image_clipboard_item_real_get_date_copied (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	GDateTime* result = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
#line 82 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_date_copied;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp1_;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 385 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_image_clipboard_item_real_get_text (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_label;
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp1_;
#line 92 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 407 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_image_clipboard_item_real_get_origin (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 98 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_origin;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp1_;
#line 100 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 429 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_image_clipboard_item_real_get_label (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 106 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_label;
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp1_;
#line 108 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 451 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_image_clipboard_item_real_get_mime_type (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 114 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 117 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = g_strdup ("image/png");
#line 117 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp0_;
#line 117 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 470 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GIcon* diodon_image_clipboard_item_real_get_icon (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	GIcon* result = NULL;
	GError * _inner_error_ = NULL;
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 483 "image-clipboard-item.c"
	{
		GFile* file = NULL;
		GdkPixbuf* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		GFileIcon* icon = NULL;
		GFileIcon* _tmp2_ = NULL;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp0_ = self->priv->_pixbuf;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp1_ = diodon_image_clipboard_item_save_tmp_pixbuf (self, _tmp0_, &_inner_error_);
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		file = _tmp1_;
#line 126 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 498 "image-clipboard-item.c"
			goto __catch7_g_error;
		}
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp2_ = (GFileIcon*) g_file_icon_new (file);
#line 127 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		icon = _tmp2_;
#line 128 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		result = G_TYPE_CHECK_INSTANCE_CAST (icon, G_TYPE_ICON, GIcon);
#line 128 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_object_unref0 (file);
#line 128 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		return result;
#line 511 "image-clipboard-item.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GIcon* _tmp6_ = NULL;
		GIcon* _tmp7_ = NULL;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		e = _inner_error_;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_inner_error_ = NULL;
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp3_ = self->priv->_checksum;
#line 130 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		g_warning ("image-clipboard-item.vala:130: Could not create icon for image %s. Fal" \
"lback to content type", _tmp3_);
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp4_ = diodon_iclipboard_item_get_mime_type (G_TYPE_CHECK_INSTANCE_CAST (self, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp5_ = _tmp4_;
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp6_ = g_content_type_get_icon (_tmp5_);
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp7_ = _tmp6_;
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_free0 (_tmp5_);
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		result = _tmp7_;
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_g_error_free0 (e);
#line 132 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		return result;
#line 546 "image-clipboard-item.c"
	}
	__finally7:
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return NULL;
#line 555 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static DiodonClipboardCategory diodon_image_clipboard_item_real_get_category (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	DiodonClipboardCategory result = 0;
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = DIODON_CLIPBOARD_CATEGORY_IMAGES;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 571 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GtkImage* diodon_image_clipboard_item_real_get_image (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	GtkImage* result = NULL;
	GdkPixbuf* pixbuf_preview = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	GtkImage* _tmp2_ = NULL;
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = diodon_image_clipboard_item_create_scaled_pixbuf (_tmp0_);
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	pixbuf_preview = _tmp1_;
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_pixbuf (pixbuf_preview);
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_object_ref_sink (_tmp2_);
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp2_;
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_object_unref0 (pixbuf_preview);
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 603 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static guint8* _vala_array_dup2 (guint8* self, int length) {
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 613 "image-clipboard-item.c"
}


static GByteArray* diodon_image_clipboard_item_real_get_payload (DiodonIClipboardItem* base, GError** error) {
	DiodonImageClipboardItem * self;
	GByteArray* result = NULL;
	guint8* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	GdkPixbuf* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gsize _tmp2_;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	GByteArray* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 156 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_pixbuf;
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	gdk_pixbuf_save_to_buffer (_tmp0_, (gchar**) (&_tmp1_), &_tmp2_, "png", &_inner_error_, NULL);
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	buffer = (g_free (buffer), NULL);
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	buffer = _tmp1_;
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	buffer_length1 = _tmp2_;
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_buffer_size_ = buffer_length1;
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		g_propagate_error (error, _inner_error_);
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		buffer = (g_free (buffer), NULL);
#line 159 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		return NULL;
#line 652 "image-clipboard-item.c"
	}
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3_ = (buffer != NULL) ? _vala_array_dup2 (buffer, buffer_length1) : ((gpointer) buffer);
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3__length1 = buffer_length1;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp4_ = g_byte_array_new_take (_tmp3_, _tmp3__length1);
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp4_;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	buffer = (g_free (buffer), NULL);
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 666 "image-clipboard-item.c"
}


/**
         * {@inheritDoc}
         */
static gchar* diodon_image_clipboard_item_real_get_checksum (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 166 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = self->priv->_checksum;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp1_;
#line 168 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 688 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static void diodon_image_clipboard_item_real_to_clipboard (DiodonIClipboardItem* base, GtkClipboard* clipboard) {
	DiodonImageClipboardItem * self;
	GtkClipboard* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	GtkClipboard* _tmp2_ = NULL;
#line 174 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 174 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_if_fail (GTK_IS_CLIPBOARD (clipboard));
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = clipboard;
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = self->priv->_pixbuf;
#line 176 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	gtk_clipboard_set_image (_tmp0_, _tmp1_);
#line 177 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = clipboard;
#line 177 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	gtk_clipboard_store (_tmp2_);
#line 714 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gboolean diodon_image_clipboard_item_real_equals (DiodonIClipboardItem* base, DiodonIClipboardItem* item) {
	DiodonImageClipboardItem * self;
	gboolean result = FALSE;
	gboolean equals = FALSE;
	DiodonIClipboardItem* _tmp0_ = NULL;
#line 183 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 185 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	equals = FALSE;
#line 187 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = item;
#line 187 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM)) {
#line 734 "image-clipboard-item.c"
		DiodonImageClipboardItem* image_item = NULL;
		DiodonIClipboardItem* _tmp1_ = NULL;
		GCompareFunc _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		DiodonImageClipboardItem* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
#line 188 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp1_ = item;
#line 188 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		image_item = (DiodonImageClipboardItem*) _tmp1_;
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp2_ = g_strcmp0;
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp3_ = self->priv->_checksum;
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp4_ = image_item;
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem)->priv->_checksum;
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp6_ = _tmp2_ (_tmp3_, _tmp5_);
#line 189 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		equals = _tmp6_ == 0;
#line 758 "image-clipboard-item.c"
	}
#line 192 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = equals;
#line 192 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 764 "image-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static guint diodon_image_clipboard_item_real_hash (DiodonIClipboardItem* base) {
	DiodonImageClipboardItem * self;
	guint result = 0U;
	GHashFunc _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
#line 198 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 201 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = g_str_hash;
#line 201 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = self->priv->_checksum;
#line 201 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = _tmp0_ (_tmp1_);
#line 201 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = _tmp2_;
#line 201 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 789 "image-clipboard-item.c"
}


/**
         * Extracts all pixbuf information which are needed to show image
         * in the view without having the pixbuf in the memory.
         *
         * @param pixbuf pixbuf to extract info from
         */
static void diodon_image_clipboard_item_extract_pixbuf_info (DiodonImageClipboardItem* self, GdkPixbuf* pixbuf) {
	GChecksum* checksum = NULL;
	GChecksum* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	guint8* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GdkPixbuf* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	GdkPixbuf* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	GdkPixbuf* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gchar* _tmp17_ = NULL;
	GdkPixbuf* _tmp18_ = NULL;
	GdkPixbuf* _tmp19_ = NULL;
#line 210 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_if_fail (DIODON_IS_IMAGE_CLIPBOARD_ITEM (self));
#line 210 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = g_checksum_new (G_CHECKSUM_SHA1);
#line 213 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	checksum = _tmp0_;
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = pixbuf;
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = gdk_pixbuf_get_pixels (_tmp1_);
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3_ = pixbuf;
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp4_ = gdk_pixbuf_get_height (_tmp3_);
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp5_ = _tmp4_;
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp6_ = pixbuf;
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp7_ = gdk_pixbuf_get_rowstride (_tmp6_);
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp8_ = _tmp7_;
#line 214 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_checksum_update (checksum, _tmp2_, (gsize) (_tmp5_ * _tmp8_));
#line 215 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp9_ = g_checksum_get_string (checksum);
#line 215 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 215 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_checksum);
#line 215 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_checksum = _tmp10_;
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp11_ = pixbuf;
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp12_ = gdk_pixbuf_get_width (_tmp11_);
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp13_ = _tmp12_;
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp14_ = pixbuf;
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp15_ = gdk_pixbuf_get_height (_tmp14_);
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp16_ = _tmp15_;
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp17_ = g_strdup_printf ("[%dx%d]", _tmp13_, _tmp16_);
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_label);
#line 218 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_label = _tmp17_;
#line 219 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp18_ = pixbuf;
#line 219 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 219 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 219 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv->_pixbuf = _tmp19_;
#line 210 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_checksum_free0 (checksum);
#line 883 "image-clipboard-item.c"
}


/**
         * Create a menu icon size scaled pix buf
         *
         * @param pixbuf scaled pixbuf
         */
static GdkPixbuf* diodon_image_clipboard_item_create_scaled_pixbuf (GdkPixbuf* pixbuf) {
	GdkPixbuf* result = NULL;
	GtkIconSize size = 0;
	gint width = 0;
	gint height = 0;
	GtkIconSize _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	GdkPixbuf* scaled = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GdkPixbuf* _tmp7_ = NULL;
#line 227 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 230 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	size = GTK_ICON_SIZE_MENU;
#line 232 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = size;
#line 232 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3_ = gtk_icon_size_lookup (_tmp0_, &_tmp1_, &_tmp2_);
#line 232 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	width = _tmp1_;
#line 232 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	height = _tmp2_;
#line 232 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	if (!_tmp3_) {
#line 234 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		width = 16;
#line 235 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		height = 16;
#line 924 "image-clipboard-item.c"
	}
#line 239 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp4_ = pixbuf;
#line 239 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp5_ = width;
#line 239 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp6_ = height;
#line 239 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp7_ = gdk_pixbuf_scale_simple (_tmp4_, _tmp5_, _tmp6_, GDK_INTERP_BILINEAR);
#line 239 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	scaled = _tmp7_;
#line 240 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = scaled;
#line 240 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 940 "image-clipboard-item.c"
}


/**
         * Store pixbuf in tmp folder but only if it does not exist
         *
         * @param pixbuf pixbuf to be stored
         * @return file object of stored pixbuf
         */
static GFile* diodon_image_clipboard_item_save_tmp_pixbuf (DiodonImageClipboardItem* self, GdkPixbuf* pixbuf, GError** error) {
	GFile* result = NULL;
	gchar* filename = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp8_ = NULL;
	GFile* _tmp9_ = NULL;
	GFile* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 249 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (DIODON_IS_IMAGE_CLIPBOARD_ITEM (self), NULL);
#line 249 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp0_ = g_get_tmp_dir ();
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp1_ = self->priv->_checksum;
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp2_ = g_strconcat ("diodon-", _tmp1_, NULL);
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp3_ = _tmp2_;
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp4_ = g_strconcat (_tmp3_, ".png", NULL);
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp5_ = _tmp4_;
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp6_ = g_build_filename (_tmp0_, _tmp5_, NULL);
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp7_ = _tmp6_;
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (_tmp5_);
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (_tmp3_);
#line 251 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	filename = _tmp7_;
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp8_ = filename;
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp9_ = g_file_new_for_path (_tmp8_);
#line 254 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	file = _tmp9_;
#line 255 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp10_ = file;
#line 255 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_tmp11_ = g_file_query_exists (_tmp10_, NULL);
#line 255 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	if (!_tmp11_) {
#line 1005 "image-clipboard-item.c"
		GdkPixbuf* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp12_ = pixbuf;
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		_tmp13_ = filename;
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		gdk_pixbuf_save (_tmp12_, _tmp13_, "png", &_inner_error_, NULL);
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
			g_propagate_error (error, _inner_error_);
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
			_g_object_unref0 (file);
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
			_g_free0 (filename);
#line 256 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
			return NULL;
#line 1024 "image-clipboard-item.c"
		}
	}
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	result = file;
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (filename);
#line 259 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return result;
#line 1033 "image-clipboard-item.c"
}


DiodonImageClipboardItem* diodon_image_clipboard_item_construct (GType object_type) {
	DiodonImageClipboardItem * self = NULL;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = (DiodonImageClipboardItem*) g_object_new (object_type, NULL);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return self;
#line 1043 "image-clipboard-item.c"
}


DiodonImageClipboardItem* diodon_image_clipboard_item_new (void) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	return diodon_image_clipboard_item_construct (DIODON_TYPE_IMAGE_CLIPBOARD_ITEM);
#line 1050 "image-clipboard-item.c"
}


static void diodon_image_clipboard_item_class_init (DiodonImageClipboardItemClass * klass) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	diodon_image_clipboard_item_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	g_type_class_add_private (klass, sizeof (DiodonImageClipboardItemPrivate));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_image_clipboard_item_finalize;
#line 1061 "image-clipboard-item.c"
}


static void diodon_image_clipboard_item_diodon_iclipboard_item_interface_init (DiodonIClipboardItemIface * iface) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	diodon_image_clipboard_item_diodon_iclipboard_item_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_clipboard_type = (DiodonClipboardType (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_clipboard_type;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_date_copied = (GDateTime* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_date_copied;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_text = (gchar* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_text;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_origin = (gchar* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_origin;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_label = (gchar* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_label;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_mime_type = (gchar* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_mime_type;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_icon = (GIcon* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_icon;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_category = (DiodonClipboardCategory (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_category;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_image = (GtkImage* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_image;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_payload = (GByteArray* (*)(DiodonIClipboardItem*, GError**)) diodon_image_clipboard_item_real_get_payload;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->get_checksum = (gchar* (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_get_checksum;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->to_clipboard = (void (*)(DiodonIClipboardItem*, GtkClipboard*)) diodon_image_clipboard_item_real_to_clipboard;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->equals = (gboolean (*)(DiodonIClipboardItem*, DiodonIClipboardItem*)) diodon_image_clipboard_item_real_equals;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	iface->hash = (guint (*)(DiodonIClipboardItem*)) diodon_image_clipboard_item_real_hash;
#line 1096 "image-clipboard-item.c"
}


static void diodon_image_clipboard_item_instance_init (DiodonImageClipboardItem * self) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self->priv = DIODON_IMAGE_CLIPBOARD_ITEM_GET_PRIVATE (self);
#line 1103 "image-clipboard-item.c"
}


static void diodon_image_clipboard_item_finalize (GObject* obj) {
	DiodonImageClipboardItem * self;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_IMAGE_CLIPBOARD_ITEM, DiodonImageClipboardItem);
#line 30 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_checksum);
#line 31 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_object_unref0 (self->priv->_pixbuf);
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_label);
#line 33 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 34 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/image-clipboard-item.vala"
	G_OBJECT_CLASS (diodon_image_clipboard_item_parent_class)->finalize (obj);
#line 1123 "image-clipboard-item.c"
}


/**
     * An image clipboard item representing such in a preview image.
     */
GType diodon_image_clipboard_item_get_type (void) {
	static volatile gsize diodon_image_clipboard_item_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_image_clipboard_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonImageClipboardItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_image_clipboard_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonImageClipboardItem), 0, (GInstanceInitFunc) diodon_image_clipboard_item_instance_init, NULL };
		static const GInterfaceInfo diodon_iclipboard_item_info = { (GInterfaceInitFunc) diodon_image_clipboard_item_diodon_iclipboard_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType diodon_image_clipboard_item_type_id;
		diodon_image_clipboard_item_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonImageClipboardItem", &g_define_type_info, 0);
		g_type_add_interface_static (diodon_image_clipboard_item_type_id, DIODON_TYPE_ICLIPBOARD_ITEM, &diodon_iclipboard_item_info);
		g_once_init_leave (&diodon_image_clipboard_item_type_id__volatile, diodon_image_clipboard_item_type_id);
	}
	return diodon_image_clipboard_item_type_id__volatile;
}



