/* text-clipboard-item.c generated by valac 0.30.2, the Vala compiler
 * generated from text-clipboard-item.vala, do not modify */

/*
 * Diodon - GTK+ clipboard manager.
 * Copyright (C) 2010-2011 Diodon Team <diodon-team@lists.launchpad.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Oliver Sauder <os@esite.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>


#define DIODON_TYPE_ICLIPBOARD_ITEM (diodon_iclipboard_item_get_type ())
#define DIODON_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem))
#define DIODON_IS_ICLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM))
#define DIODON_ICLIPBOARD_ITEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItemIface))

typedef struct _DiodonIClipboardItem DiodonIClipboardItem;
typedef struct _DiodonIClipboardItemIface DiodonIClipboardItemIface;

#define DIODON_TYPE_CLIPBOARD_TYPE (diodon_clipboard_type_get_type ())

#define DIODON_TYPE_CLIPBOARD_CATEGORY (diodon_clipboard_category_get_type ())

#define DIODON_TYPE_TEXT_CLIPBOARD_ITEM (diodon_text_clipboard_item_get_type ())
#define DIODON_TEXT_CLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem))
#define DIODON_TEXT_CLIPBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItemClass))
#define DIODON_IS_TEXT_CLIPBOARD_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIODON_TYPE_TEXT_CLIPBOARD_ITEM))
#define DIODON_IS_TEXT_CLIPBOARD_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIODON_TYPE_TEXT_CLIPBOARD_ITEM))
#define DIODON_TEXT_CLIPBOARD_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItemClass))

typedef struct _DiodonTextClipboardItem DiodonTextClipboardItem;
typedef struct _DiodonTextClipboardItemClass DiodonTextClipboardItemClass;
typedef struct _DiodonTextClipboardItemPrivate DiodonTextClipboardItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DIODON_CLIPBOARD_TYPE_NONE,
	DIODON_CLIPBOARD_TYPE_CLIPBOARD,
	DIODON_CLIPBOARD_TYPE_PRIMARY
} DiodonClipboardType;

typedef enum  {
	DIODON_CLIPBOARD_CATEGORY_CLIPBOARD = 0,
	DIODON_CLIPBOARD_CATEGORY_TEXT,
	DIODON_CLIPBOARD_CATEGORY_FILES,
	DIODON_CLIPBOARD_CATEGORY_IMAGES
} DiodonClipboardCategory;

struct _DiodonIClipboardItemIface {
	GTypeInterface parent_iface;
	DiodonClipboardType (*get_clipboard_type) (DiodonIClipboardItem* self);
	gchar* (*get_label) (DiodonIClipboardItem* self);
	gchar* (*get_mime_type) (DiodonIClipboardItem* self);
	DiodonClipboardCategory (*get_category) (DiodonIClipboardItem* self);
	GtkImage* (*get_image) (DiodonIClipboardItem* self);
	GIcon* (*get_icon) (DiodonIClipboardItem* self);
	GByteArray* (*get_payload) (DiodonIClipboardItem* self, GError** error);
	GDateTime* (*get_date_copied) (DiodonIClipboardItem* self);
	gchar* (*get_text) (DiodonIClipboardItem* self);
	gchar* (*get_checksum) (DiodonIClipboardItem* self);
	gchar* (*get_origin) (DiodonIClipboardItem* self);
	void (*to_clipboard) (DiodonIClipboardItem* self, GtkClipboard* clipboard);
	gboolean (*equals) (DiodonIClipboardItem* self, DiodonIClipboardItem* item);
	guint (*hash) (DiodonIClipboardItem* self);
};

struct _DiodonTextClipboardItem {
	GObject parent_instance;
	DiodonTextClipboardItemPrivate * priv;
};

struct _DiodonTextClipboardItemClass {
	GObjectClass parent_class;
};

struct _DiodonTextClipboardItemPrivate {
	gchar* _text;
	gchar* _origin;
	DiodonClipboardType _clipboard_type;
	GDateTime* _date_copied;
};


static gpointer diodon_text_clipboard_item_parent_class = NULL;
static DiodonIClipboardItemIface* diodon_text_clipboard_item_diodon_iclipboard_item_parent_iface = NULL;

GType diodon_clipboard_type_get_type (void) G_GNUC_CONST;
GType diodon_clipboard_category_get_type (void) G_GNUC_CONST;
GType diodon_iclipboard_item_get_type (void) G_GNUC_CONST;
GType diodon_text_clipboard_item_get_type (void) G_GNUC_CONST;
#define DIODON_TEXT_CLIPBOARD_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItemPrivate))
enum  {
	DIODON_TEXT_CLIPBOARD_ITEM_DUMMY_PROPERTY
};
DiodonTextClipboardItem* diodon_text_clipboard_item_new (DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied);
DiodonTextClipboardItem* diodon_text_clipboard_item_construct (GType object_type, DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied);
static DiodonClipboardType diodon_text_clipboard_item_real_get_clipboard_type (DiodonIClipboardItem* base);
static GDateTime* diodon_text_clipboard_item_real_get_date_copied (DiodonIClipboardItem* base);
static gchar* diodon_text_clipboard_item_real_get_text (DiodonIClipboardItem* base);
static gchar* diodon_text_clipboard_item_real_get_origin (DiodonIClipboardItem* base);
static gchar* diodon_text_clipboard_item_real_get_label (DiodonIClipboardItem* base);
static gchar* diodon_text_clipboard_item_real_get_mime_type (DiodonIClipboardItem* base);
static DiodonClipboardCategory diodon_text_clipboard_item_real_get_category (DiodonIClipboardItem* base);
static GtkImage* diodon_text_clipboard_item_real_get_image (DiodonIClipboardItem* base);
static GIcon* diodon_text_clipboard_item_real_get_icon (DiodonIClipboardItem* base);
gchar* diodon_iclipboard_item_get_mime_type (DiodonIClipboardItem* self);
static GByteArray* diodon_text_clipboard_item_real_get_payload (DiodonIClipboardItem* base, GError** error);
static gchar* diodon_text_clipboard_item_real_get_checksum (DiodonIClipboardItem* base);
static void diodon_text_clipboard_item_real_to_clipboard (DiodonIClipboardItem* base, GtkClipboard* clipboard);
static gboolean diodon_text_clipboard_item_real_equals (DiodonIClipboardItem* base, DiodonIClipboardItem* item);
gchar* diodon_iclipboard_item_get_text (DiodonIClipboardItem* self);
static guint diodon_text_clipboard_item_real_hash (DiodonIClipboardItem* base);
static void diodon_text_clipboard_item_finalize (GObject* obj);


/**
         * Default data constructor needed for reflection.
         * 
         * @param clipboard_type clipboard type item is coming from
         * @param data simple text
         * @param origin origin of clipboard item as application path
         */
static gpointer _g_date_time_ref0 (gpointer self) {
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 151 "text-clipboard-item.c"
}


DiodonTextClipboardItem* diodon_text_clipboard_item_construct (GType object_type, DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied) {
	DiodonTextClipboardItem * self = NULL;
	DiodonClipboardType _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDateTime* _tmp5_ = NULL;
	GDateTime* _tmp6_ = NULL;
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	g_return_val_if_fail (date_copied != NULL, NULL);
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = (DiodonTextClipboardItem*) g_object_new (object_type, NULL);
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = clipboard_type;
#line 43 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self->priv->_clipboard_type = _tmp0_;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = data;
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_free0 (self->priv->_text);
#line 44 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self->priv->_text = _tmp2_;
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp3_ = origin;
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 45 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self->priv->_origin = _tmp4_;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp5_ = date_copied;
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp6_ = _g_date_time_ref0 (_tmp5_);
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 46 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self->priv->_date_copied = _tmp6_;
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return self;
#line 200 "text-clipboard-item.c"
}


DiodonTextClipboardItem* diodon_text_clipboard_item_new (DiodonClipboardType clipboard_type, const gchar* data, const gchar* origin, GDateTime* date_copied) {
#line 41 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return diodon_text_clipboard_item_construct (DIODON_TYPE_TEXT_CLIPBOARD_ITEM, clipboard_type, data, origin, date_copied);
#line 207 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static DiodonClipboardType diodon_text_clipboard_item_real_get_clipboard_type (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	DiodonClipboardType result = 0;
	DiodonClipboardType _tmp0_ = 0;
#line 52 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = self->priv->_clipboard_type;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp0_;
#line 54 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 226 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GDateTime* diodon_text_clipboard_item_real_get_date_copied (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	GDateTime* result = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
#line 60 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = self->priv->_date_copied;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp1_;
#line 62 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 248 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_text_clipboard_item_real_get_text (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 68 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 70 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = self->priv->_text;
#line 70 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 70 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp1_;
#line 70 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 270 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_text_clipboard_item_real_get_origin (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 76 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = self->priv->_origin;
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp1_;
#line 78 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 292 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1282 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1282 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1282 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 308 "text-clipboard-item.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 339 "text-clipboard-item.c"
				goto __catch9_g_regex_error;
			}
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1284 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			return NULL;
#line 348 "text-clipboard-item.c"
		}
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 364 "text-clipboard-item.c"
				goto __catch9_g_regex_error;
			}
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			return NULL;
#line 375 "text-clipboard-item.c"
		}
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1285 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 389 "text-clipboard-item.c"
	}
	goto __finally9;
	__catch9_g_regex_error:
	{
		GError* e = NULL;
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1287 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 403 "text-clipboard-item.c"
	}
	__finally9:
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1283 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return NULL;
#line 414 "text-clipboard-item.c"
	}
}


static gint string_index_of_nth_char (const gchar* self, glong c) {
	gint result = 0;
	glong _tmp0_ = 0L;
	gchar* _tmp1_ = NULL;
#line 1046 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1047 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp0_ = c;
#line 1047 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_offset_to_pointer (self, _tmp0_);
#line 1047 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	result = (gint) (_tmp1_ - ((gchar*) self));
#line 1047 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	return result;
#line 433 "text-clipboard-item.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1197 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1197 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1197 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1197 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1198 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1198 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 456 "text-clipboard-item.c"
		glong _tmp4_ = 0L;
#line 1199 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1199 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1199 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 464 "text-clipboard-item.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1201 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1201 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1201 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1201 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 476 "text-clipboard-item.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1208 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1210 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1210 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 500 "text-clipboard-item.c"
		glong _tmp2_ = 0L;
#line 1210 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1210 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 506 "text-clipboard-item.c"
	} else {
#line 1210 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 510 "text-clipboard-item.c"
	}
#line 1210 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 514 "text-clipboard-item.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1212 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1212 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1212 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1212 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 526 "text-clipboard-item.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1214 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1214 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1214 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 536 "text-clipboard-item.c"
	}
#line 1217 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1217 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 542 "text-clipboard-item.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1218 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1218 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1218 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1219 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1219 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 556 "text-clipboard-item.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1221 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1221 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1221 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 566 "text-clipboard-item.c"
	}
#line 1223 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1223 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 572 "text-clipboard-item.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1224 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1224 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1224 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 581 "text-clipboard-item.c"
	}
#line 1226 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1226 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1226 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1226 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1227 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1227 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1227 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1227 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1227 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	return result;
#line 601 "text-clipboard-item.c"
}


static gchar* diodon_text_clipboard_item_real_get_label (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	gchar* result = NULL;
	gchar* label = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
#line 84 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = self->priv->_text;
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = string_replace (_tmp0_, "\n", " ");
#line 87 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	label = _tmp1_;
#line 88 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp2_ = label;
#line 88 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp3_ = g_utf8_strlen (_tmp2_, (gssize) -1);
#line 88 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	if (_tmp3_ > 50) {
#line 627 "text-clipboard-item.c"
		glong index_char = 0L;
		const gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		const gchar* _tmp6_ = NULL;
		glong _tmp7_ = 0L;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp4_ = label;
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp5_ = string_index_of_nth_char (_tmp4_, (glong) 50);
#line 89 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		index_char = (glong) _tmp5_;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp6_ = label;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp7_ = index_char;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp8_ = string_substring (_tmp6_, (glong) 0, _tmp7_);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp9_ = _tmp8_;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp10_ = g_strconcat (_tmp9_, "...", NULL);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_g_free0 (label);
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		label = _tmp10_;
#line 90 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_g_free0 (_tmp9_);
#line 658 "text-clipboard-item.c"
	}
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = label;
#line 93 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 664 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_text_clipboard_item_real_get_mime_type (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 99 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = g_strdup ("text/plain");
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp0_;
#line 101 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 683 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static DiodonClipboardCategory diodon_text_clipboard_item_real_get_category (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	DiodonClipboardCategory result = 0;
#line 107 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = DIODON_CLIPBOARD_CATEGORY_TEXT;
#line 109 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 699 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GtkImage* diodon_text_clipboard_item_real_get_image (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	GtkImage* result = NULL;
#line 115 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 117 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = NULL;
#line 117 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 715 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GIcon* diodon_text_clipboard_item_real_get_icon (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	GIcon* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GIcon* _tmp2_ = NULL;
	GIcon* _tmp3_ = NULL;
#line 123 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = diodon_iclipboard_item_get_mime_type (G_TYPE_CHECK_INSTANCE_CAST (self, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = _tmp0_;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp2_ = g_content_type_get_icon (_tmp1_);
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp3_ = _tmp2_;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_free0 (_tmp1_);
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp3_;
#line 125 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 745 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static GByteArray* diodon_text_clipboard_item_real_get_payload (DiodonIClipboardItem* base, GError** error) {
	DiodonTextClipboardItem * self;
	GByteArray* result = NULL;
#line 131 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 133 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = NULL;
#line 133 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 761 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gchar* diodon_text_clipboard_item_real_get_checksum (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 139 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = self->priv->_text;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = g_compute_checksum_for_string (G_CHECKSUM_SHA1, _tmp0_, (gsize) -1);
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp1_;
#line 141 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 783 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static void diodon_text_clipboard_item_real_to_clipboard (DiodonIClipboardItem* base, GtkClipboard* clipboard) {
	DiodonTextClipboardItem * self;
	GtkClipboard* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GtkClipboard* _tmp2_ = NULL;
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 147 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	g_return_if_fail (GTK_IS_CLIPBOARD (clipboard));
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = clipboard;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = self->priv->_text;
#line 149 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	gtk_clipboard_set_text (_tmp0_, _tmp1_, -1);
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp2_ = clipboard;
#line 150 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	gtk_clipboard_store (_tmp2_);
#line 809 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static gboolean diodon_text_clipboard_item_real_equals (DiodonIClipboardItem* base, DiodonIClipboardItem* item) {
	DiodonTextClipboardItem * self;
	gboolean result = FALSE;
	gboolean equals = FALSE;
	DiodonIClipboardItem* _tmp0_ = NULL;
#line 156 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 158 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	equals = FALSE;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = item;
#line 160 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DIODON_TYPE_TEXT_CLIPBOARD_ITEM)) {
#line 829 "text-clipboard-item.c"
		GCompareFunc _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		DiodonIClipboardItem* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp1_ = g_strcmp0;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp2_ = self->priv->_text;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp3_ = item;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp4_ = diodon_iclipboard_item_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, DIODON_TYPE_ICLIPBOARD_ITEM, DiodonIClipboardItem));
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp5_ = _tmp4_;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_tmp6_ = _tmp1_ (_tmp2_, _tmp5_);
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		equals = _tmp6_ == 0;
#line 161 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
		_g_free0 (_tmp5_);
#line 852 "text-clipboard-item.c"
	}
#line 164 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = equals;
#line 164 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 858 "text-clipboard-item.c"
}


/**
     * {@inheritDoc}
     */
static guint diodon_text_clipboard_item_real_hash (DiodonIClipboardItem* base) {
	DiodonTextClipboardItem * self;
	guint result = 0U;
	GHashFunc _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
#line 170 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp0_ = g_str_hash;
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp1_ = self->priv->_text;
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_tmp2_ = _tmp0_ (_tmp1_);
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	result = _tmp2_;
#line 172 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	return result;
#line 883 "text-clipboard-item.c"
}


static void diodon_text_clipboard_item_class_init (DiodonTextClipboardItemClass * klass) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	diodon_text_clipboard_item_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	g_type_class_add_private (klass, sizeof (DiodonTextClipboardItemPrivate));
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	G_OBJECT_CLASS (klass)->finalize = diodon_text_clipboard_item_finalize;
#line 894 "text-clipboard-item.c"
}


static void diodon_text_clipboard_item_diodon_iclipboard_item_interface_init (DiodonIClipboardItemIface * iface) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	diodon_text_clipboard_item_diodon_iclipboard_item_parent_iface = g_type_interface_peek_parent (iface);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_clipboard_type = (DiodonClipboardType (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_clipboard_type;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_date_copied = (GDateTime* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_date_copied;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_text = (gchar* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_text;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_origin = (gchar* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_origin;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_label = (gchar* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_label;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_mime_type = (gchar* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_mime_type;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_category = (DiodonClipboardCategory (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_category;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_image = (GtkImage* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_image;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_icon = (GIcon* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_icon;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_payload = (GByteArray* (*)(DiodonIClipboardItem*, GError**)) diodon_text_clipboard_item_real_get_payload;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->get_checksum = (gchar* (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_get_checksum;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->to_clipboard = (void (*)(DiodonIClipboardItem*, GtkClipboard*)) diodon_text_clipboard_item_real_to_clipboard;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->equals = (gboolean (*)(DiodonIClipboardItem*, DiodonIClipboardItem*)) diodon_text_clipboard_item_real_equals;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	iface->hash = (guint (*)(DiodonIClipboardItem*)) diodon_text_clipboard_item_real_hash;
#line 929 "text-clipboard-item.c"
}


static void diodon_text_clipboard_item_instance_init (DiodonTextClipboardItem * self) {
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self->priv = DIODON_TEXT_CLIPBOARD_ITEM_GET_PRIVATE (self);
#line 936 "text-clipboard-item.c"
}


static void diodon_text_clipboard_item_finalize (GObject* obj) {
	DiodonTextClipboardItem * self;
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIODON_TYPE_TEXT_CLIPBOARD_ITEM, DiodonTextClipboardItem);
#line 29 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_free0 (self->priv->_text);
#line 30 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_free0 (self->priv->_origin);
#line 32 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	_g_date_time_unref0 (self->priv->_date_copied);
#line 27 "/builddir/build/BUILD/diodon-1.5.0/libdiodon/text-clipboard-item.vala"
	G_OBJECT_CLASS (diodon_text_clipboard_item_parent_class)->finalize (obj);
#line 952 "text-clipboard-item.c"
}


/**
     * Represents a text clipboard item holding simple text.
     */
GType diodon_text_clipboard_item_get_type (void) {
	static volatile gsize diodon_text_clipboard_item_type_id__volatile = 0;
	if (g_once_init_enter (&diodon_text_clipboard_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DiodonTextClipboardItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diodon_text_clipboard_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DiodonTextClipboardItem), 0, (GInstanceInitFunc) diodon_text_clipboard_item_instance_init, NULL };
		static const GInterfaceInfo diodon_iclipboard_item_info = { (GInterfaceInitFunc) diodon_text_clipboard_item_diodon_iclipboard_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType diodon_text_clipboard_item_type_id;
		diodon_text_clipboard_item_type_id = g_type_register_static (G_TYPE_OBJECT, "DiodonTextClipboardItem", &g_define_type_info, 0);
		g_type_add_interface_static (diodon_text_clipboard_item_type_id, DIODON_TYPE_ICLIPBOARD_ITEM, &diodon_iclipboard_item_info);
		g_once_init_leave (&diodon_text_clipboard_item_type_id__volatile, diodon_text_clipboard_item_type_id);
	}
	return diodon_text_clipboard_item_type_id__volatile;
}



